當前位置:首頁 » 編程語言 » python文件異常

python文件異常

發布時間: 2022-06-24 08:44:36

『壹』 python(unsubscriptable object異常)

python(unsubscriptable object異常),是設置錯誤造成的,解決方法如下;

1、首先創建一個py文件,輸入「for i in range(10):y=1if i==5:y=0i=i/yprint(i)」代碼,如下圖所示。

『貳』 Python中錯誤與異常的規范

8. 錯誤和異常
至今為止還沒有進一步的談論過錯誤信息,不過在你已經試驗過的那些例子中,可能已經遇到過一些。Python 中(至少)有兩種錯誤:語法錯誤和異常( syntax errors 和 exceptions )。
8.1. 語法錯誤
語法錯誤,也被稱作解析錯誤,也許是你學習 Python 過程中最常見抱怨:
>>> while True print('Hello world')
File "
", line 1, in ?
while True print('Hello world')
^
SyntaxError: invalid syntax
語法分析器指出錯誤行,並且在檢測到錯誤的位置前面顯示一個小「箭頭」。 錯誤是由箭頭 前面 的標記引起的(或者至少是這么檢測的): 這個例子中,函數 print() 被發現存在錯誤,因為它前面少了一個冒號( ':' )。 錯誤會輸出文件名和行號,所以如果是從腳本輸入的你就知道去哪裡檢查錯誤了。

『叄』 python程序運行時報錯,怎麼處理

1.異常種類

python中的異常種類非常多,每個異常專門用於處理某一項異常!!!

下面是一些常用的異常:

『肆』 Python中程序異常都能被處理嗎

「異常」是Python對象,表示一個錯誤。

如果不想出現異常後程序自動停止運行,編程的人,就要主動捕捉異常,並自己作出相應處理。

捕捉異常可以使用try/except語句。

try/except語句用來檢測try語句塊中的錯誤,從而讓except語句捕獲異常信息並處理。

下面是try/except的示例,說明了怎樣處理各種異常:

try:

<語句> #運行別的代碼

except <名字>:

<語句> #如果在try部份引發了'name'異常

except <名字>,<數據>:

<語句> #如果引發了'name'異常,獲得附加的數據

else:

<語句> #如果沒有異常發生

Python的各種標准異常是預先定義好的。基本上包括了常見的異常情況,主要有以下內容。

異常名稱 描述

BaseException 所有異常的基類

SystemExit 解釋器請求退出

KeyboardInterrupt 用戶中斷執行(通常是輸入^C)

Exception 常規錯誤的基類

StopIteration 迭代器沒有更多的值

GeneratorExit 生成器(generator)發生異常來通知退出

StandardError 所有的內建標准異常的基類

ArithmeticError 所有數值計算錯誤的基類

FloatingPointError 浮點計算錯誤

OverflowError 數值運算超出最大限制

ZeroDivisionError 除(或取模)零 (所有數據類型)

AssertionError 斷言語句失敗

AttributeError 對象沒有這個屬性

EOFError 沒有內建輸入,到達EOF 標記

EnvironmentError 操作系統錯誤的基類

IOError 輸入/輸出操作失敗

OSError 操作系統錯誤

WindowsError 系統調用失敗

ImportError 導入模塊/對象失敗

LookupError 無效數據查詢的基類

IndexError 序列中沒有此索引(index)

KeyError 映射中沒有這個鍵

MemoryError 內存溢出錯誤(對於Python 解釋器不是致命的)

NameError 未聲明/初始化對象 (沒有屬性)

UnboundLocalError 訪問未初始化的本地變數

ReferenceError 弱引用(Weak reference)試圖訪問已經垃圾回收了的對象

RuntimeError 一般的運行時錯誤

NotImplementedError 尚未實現的方法

SyntaxError Python 語法錯誤

IndentationError 縮進錯誤

TabError Tab 和空格混用

SystemError 一般的解釋器系統錯誤

TypeError 對類型無效的操作

ValueError 傳入無效的參數

UnicodeError Unicode 相關的錯誤

UnicodeDecodeError Unicode 解碼時的錯誤

UnicodeEncodeError Unicode 編碼時錯誤

UnicodeTranslateError Unicode 轉換時錯誤

Warning 警告的基類

DeprecationWarning 關於被棄用的特徵的警告

FutureWarning 關於構造將來語義會有改變的警告

OverflowWarning 舊的關於自動提升為長整型(long)的警告

PendingDeprecationWarning 關於特性將會被廢棄的警告

RuntimeWarning 可疑的運行時行為(runtime behavior)的警告

SyntaxWarning 可疑的語法的警告

UserWarning 用戶代碼生成的警告

Python系統處理異常就是提示一下,停止運行。不想停止,只有自己處理。

可以不帶類型,所有異常執行同一組語句:

try:
正常的操作
except:
發生異常,執行這塊代碼
else:
如果沒有異常執行這塊代碼


也可以多個異常共用一段代碼:

ry:
正常的操作
except(Exception1[, Exception2[,...ExceptionN]]]):
發生以上多個異常中的一個,執行這塊代碼
else:
如果沒有異常執行這塊代碼

還有一種格式,可以有finally部分:

try:
fh = open("testfile", "w")
try:
fh.write("這是一個測試文件,用於測試異常!!")
finally:
print "關閉文件"
fh.close()except IOError:
print "Error: 沒有找到文件或讀取文件失敗"

當在try塊中拋出一個異常,立即執行finally塊代碼。

finally塊中的所有語句執行後,異常被再次觸發,並執行except塊代碼。

參數的內容不同於異常。

除了標准異常,我們也可以自己定義異常,並進行處理,這時用到raise語句:

raise [Exception [, args [, traceback]]]

語句中 Exception 是異常的類型(例如,NameError)參數標准異常中任一種,args 是自已提供的異常參數。

最後一個參數是可選的(在實踐中很少使用),如果存在,是跟蹤異常對象。

相應的異常處理程序示例如下:

try:
正常語句,內含raise語句

except Exception,err:
觸發自定義異常

else:
其餘代碼

『伍』 關於python的異常

原因是這個文件在c盤,你以寫方式打開,許可權不足。
你可以:
1,以管理員許可權運行IDLE,不過不推薦,因為你正在學習過程中,有可能誤操作導致覆蓋/刪除重要的系統文件,使系統工作不正常甚至崩潰。對於初學編程的你,想必也是一個嚴峻的問題。
2,在非系統盤上做這些事情,平時在某個盤專門建立一個學習/測試的目錄。
另外一個建議,多學點英語,會有用的,最起碼能看懂錯誤說的是啥。

『陸』 Python 運行報錯NameError出現原因,怎麼解決

python程序,報錯NameError: name XX is not defined 是沒有聲明造成的,需要在文件的前兩行進行聲明編碼,聲明方法為:

1、寫一個python文件,文件中有中文字元,且未聲明編碼。

『柒』 python異常值處理

如果你用 Python 編程,那麼你就無法避開異常,因為異常在這門語言里無處不在。打個比方,當你在腳本執行時按 ctrl+c 退出,解釋器就會產生一個 KeyboardInterrupt 異常。而 KeyError、ValueError、TypeError 等更是日常編程里隨處可見的老朋友。

異常處理工作由「捕獲」和「拋出」兩部分組成。「捕獲」指的是使用 try ... except 包裹特定語句,妥當的完成錯誤流程處理。而恰當的使用 raise 主動「拋出」異常,更是優雅代碼里必不可少的組成部分。

異常分類

BaseException所有異常的基類
Exception常見錯誤的基類
ArithmeticError所有數值計算錯誤的基類
Warning警告的基類

AssertError斷言語句(assert)失敗
AttributeError嘗試訪問未知的對象屬性
DeprecattionWarning關於被棄用的特徵的警告
EOFError用戶輸入文件末尾標志EOF(Ctrl+d)
FloattingPointError浮點計算錯誤
FutureWarning關於構造將來語義會有改變的警告
GeneratorExitgenerator.close()方法被調用的時候
ImportError導入模塊失敗的時候
IndexError索引超出序列的范圍
KeyError字典中查找一個不存在的關鍵字
KeyboardInterrupt用戶輸入中斷鍵(Ctrl+c)
MemoryError內存溢出(可通過刪除對象釋放內存)
NamerError嘗試訪問一個不存在的變數
NotImplementedError尚未實現的方法
OSError操作系統產生的異常(例如打開一個不存在的文件)
OverflowError數值運算超出最大限制
OverflowWarning舊的關於自動提升為長整型(long)的警告
PendingDeprecationWarning關於特徵會被遺棄的警告
ReferenceError弱引用(weakreference)試圖訪問一個已經被垃圾回收機制回收了的對象
RuntimeError一般的運行時錯誤
RuntimeWarning可疑的運行行為(runtimebehavior)的警告
StopIteration迭代器沒有更多的值
SyntaxErrorPython的語法錯誤
SyntaxWarning可疑的語法的警告
IndentationError縮進錯誤
TabErrorTab和空格混合使用
SystemErrorPython編譯器系統錯誤
SystemExitPython編譯器進程被關閉
TypeError不同類型間的無效操作
UnboundLocalError訪問一個未初始化的本地變數(NameError的子類)
UnicodeErrorUnicode相關的錯誤(ValueError的子類)
UnicodeEncodeErrorUnicode編碼時的錯誤(UnicodeError的子類)
UnicodeDecodeErrorUnicode解碼時的錯誤(UnicodeError的子類)
UserWarning用戶代碼生成的警告
ValueError傳入無效的參數
ZeroDivisionError除數為零

『捌』 python運行錯誤怎麼辦

  1. 一、python的錯誤處理:

    在程序運行的過程中,如果發生了錯誤,可以事先約定返回一個錯誤代碼,這樣,就可以知道是否有錯以及出錯的原因。
    在操作系統提供的調用中,返回錯誤碼非常常見。比如打開文件的函數open(),成功時返迴文件的描述符(就是一個整數),出錯時返回-1用錯誤碼來表示是否出錯十分不便,因為函數本身應該返回的正常結果和錯誤碼混在一起,造成調用者必須大量的代碼來判斷是否出錯:def foo():
    r = somefunction() if r == (-1): return (-1) return rdef bar():
    r = foo() if r == (-1): print("Error") else: pass一旦出錯,還要一級一級上報,直到某個函數可以處理該錯誤(比如,給用戶輸出一個錯誤信息)

    所以,高級語言通常都內置了一套try...except...finally...的錯誤處理機制,python也不例外。try
    讓我們用一個例子來看看try的機制try: print("try....")
    r = 10 / 0 print("result", r)except ZeroDivisionError as e: print("except:", e)finally: print("finally...")print("END....")

    當我們認為某些代碼可能會出錯時,就可以用try來運行這段代碼,如果執行出錯,則後續代碼不會繼續執行
    而是直接跳轉至錯誤處理代碼,即except語句塊
    執行完except後,如果有finally語句塊,則執行finally語句塊,至此,執行完畢。

    上面的代碼在計算10 / 0時 會產生一個除法運算錯誤:try....except: division by zerofinally...
    END....>>>從輸出可以看到,當錯誤發生時,後續語句print("result:", r)不會被執行,except由於捕獲到ZeroDivisionError因此被執行。
    最後,finally語句被執行。然後,程序繼續按照流程往下走。

    如果把除數0 變成2,則執行結果如下try....
    result 5.0finally...
    END....>>>由於沒有錯誤發生,所以except語句塊不會被執行,但是finally如果有則一定會被執行,當然finally也可以沒有
    你還可以猜測,錯誤應該有很多種類,日過發生了不同類型的錯誤,應該由不同的except語句塊處理。
    沒錯,可以有多個except來捕獲不同類型的錯誤:try: print("try.....")
    r = 10 / int("a") print("result:", r)except ValueError as e: print("ValueError:", e)except ZeroDivisionError as e: print("ZeroDivisionError:", e)finally: print("finally...")print("END...")

    int()函數可能會拋出ValueError,所以我們用一個except捕獲ValueError,用另一個except捕獲ZeroDivisionError
    此外,如果沒有錯誤發生,可以再except語句塊後面加一個else,當沒有錯誤發生時,會自動執行else語句。try: print("try...")
    r = 10 / int("2") print("result:", r)except ValueError as e: print("ValueError:", e)except ZeroDivisionError as e: print("ZeroDivisionError:", e)else: print("No error!")finally: print("finally...")print("END")

    python的錯誤其實也是class,所有的錯誤類型都繼承自BaseException,
    所以在使用except時需要注意的是,它不但捕獲該類型的錯誤,還把其子類也「一網打盡」。
    比如:try:
    foo()except ValueError as e: print("ValueError")except UnicodeError as e: print("UnicodeError")

    第二個except永遠也捕獲不到UnicodeError, 因為UnicodeError是ValueError的子類
    如果有,也是被第一個except給捕獲了。
    python所有的錯誤都是BaseException類派生的。

    所有常見的錯誤類型和繼承關系看這里:
    https://docs.python.org/3/library/exceptions.html#exception-hierarchy使用try...exccept捕獲錯誤還有一個巨大的好處,就是可以跨越多層調用,比如函數main()調用foo()
    foo()調用bar(),結果bar()出錯了,這時,只要main()捕獲到了,就可以處理:def foo(s): return 10 / int(s)def bar(s): return foo(s) * 2def main(): try:
    bar("0") except Exception as e: print("Error:", e) finally: print("finally...")

    也就是說,不需要在每個可能出錯的地方去捕獲異常,只要在合適的層次去捕獲就可以了。
    這樣一來,就大大減少了寫 try...except...finally的麻煩。


    二、調用堆棧

    如果錯誤沒有被捕獲,他就會一直往上拋,最後被python解釋器捕獲,列印一個錯誤信息,然後程序退出。def foo(s): return 10 / int(s)def bar(s): return foo(s) * 2def main():
    bar("0")

    main()

    執行結果為:

    Traceback (most recent call last):
    File "C:/Python36/test.py", line 10, in <mole>
    main()
    File "C:/Python36/test.py", line 8, in main
    bar("0")
    File "C:/Python36/test.py", line 5, in bar return foo(s) * 2
    File "C:/Python36/test.py", line 2, in foo return 10 / int(s)
    ZeroDivisionError: division by zero

    出錯並不可怕,可怕的時不知道哪裡出錯了。解讀錯誤信息時定位錯誤的關鍵。
    我們從上往下可以看到整個錯誤的調用函數鏈。

    錯誤第一行:
    Traceback (most recent call last):
    這告訴我們的是錯誤的跟蹤信息。

    File "C:/Python36/test.py", line 10, in < mole >main()
    說明調用main()出錯了,在代碼文件test.py中第10行,但是原因是第8行:

    File"C:/Python36/test.py", line8, in main
    bar("0")
    調用bar("0")出錯了,在代碼文件test.py中第8行,但原因是第5行:


    File"C:/Python36/test.py", line5, in barreturn foo(s) * 2調用return foo(s) * 2時出錯了,在test.py中第5行,但原因是第2行


    File "C:/Python36/test.py", line 2, in foo return 10 / int(s)
    ZeroDivisionError: division by zero

    這時我們找到了源頭,原來在第2行調用return 10 / int(s)出錯了,錯誤為ZeroDivisionError


    三、記錄錯誤

    如果不捕獲錯誤,自然可以讓python解釋器來列印出錯誤堆棧,但是程序也被結束了。
    既然我們能捕獲錯誤,就可以把錯誤堆棧列印出來,然後分析錯誤原因,同時,讓程序繼續執行下去。

    python內置的logging模塊可以非常容易地記錄錯誤信息:import loggingdef foo(s): return 10 / int(s)def bar(s): return foo(s) * 2def main(): try:
    bar("0") except Exception as e:
    logging.exception(e)

    main()print("END")

    輸出結果為:
    ERROR:root:division by zero
    Traceback (most recent call last):
    File "C:/Python36/test.py", line 12, in main
    bar("0")
    File "C:/Python36/test.py", line 8, in bar return foo(s) * 2
    File "C:/Python36/test.py", line 5, in foo return 10 / int(s)
    ZeroDivisionError: division by zero
    END

    同樣是出錯,但程序列印完錯誤信息後會繼續執行,並正常退出。

    通過配置,logging還可以把錯誤記錄到日誌文件里,方便事後排查。


    四、拋出錯誤

    因為錯誤是class,捕獲一個錯誤就是捕獲到該class的一個實例。
    因此,錯誤並不是憑空產生的,而是有意創建並拋出的。

    python的內置函數會拋出很多類型的錯誤,我們自己編寫的函數也可以拋出錯誤。

    如果要拋出錯誤,首先根據需要,可以定義一個錯誤的class,選擇好繼承關系,然後用raise語句拋出一個錯誤的實例:class FooError(ValueError): passdef foo(s):
    n = int(s) if n == 0: raise FooError("invalid value: %s" % s) return 10 / n

    foo("0")

    輸出結果:
    Traceback (most recent call last):
    File "C:/Python36/test.py", line 10, in <mole>
    foo("0")
    File "C:/Python36/test.py", line 7, in foo raise FooError("invalid value: %s" % s)
    FooError: invalid value: 0

    只有在必要的時候才定義我們自己的錯誤類型。
    如果可以選擇python已有的內置錯誤類型(比如ValueError, TypeError),盡量使用python內置的錯誤類型。

    最後,我們來看另一種錯誤處理方式:def foo(s):
    n = int(s) if n == 0: raise ValueError("invalid value: %s" % s) return 10 / ndef bar(): try:
    foo("0") except ValueError as e: print("ValieError") raisebar()

    在bar()函數中,我們明明已經捕獲了錯誤,但是,列印一個ValueError之後
    又通過raise語句拋出去了。這不是有病嗎

    其實,這種錯誤處理方式不但沒病,而且相當常見。
    捕獲錯誤目的只是記錄一下,便於或許追蹤。

    但是,由於當前函數不知道應該怎麼處理該錯誤,所以,最恰當的方式是繼續往上拋,讓頂層調用者去處理。
    好比一個員工處理不了一個問題時,就把問題一直往上拋,最終會拋給CEO去解決。

    注意:raise語句如果不帶參數,就會把當前錯誤原樣拋出。
    此外,在except中raise一個Error,還可以改寫錯誤類型try: 10 / 0except ZeroDivisionError: raise ValueError("do not input zero!")

    輸出結果:
    Traceback (most recent call last):
    File "C:/Python36/test.py", line 4, in <mole> raise ValueError("do not input zero!")
    ValueError: do not input zero!>>>只要是合理的轉換邏輯就可以,但是,絕不應該把一個IOError轉成毫不相乾的valueError.

    總結:

    python內置的 try...except...finally 用來處理錯誤十分方便。
    出錯時,會分析錯誤信息並定位錯誤發生的代碼位置才是關鍵的。

    程序也可以主動拋出錯誤,讓調用者來處理相應的錯誤。
    但是應該在文檔中寫清楚可能會拋出哪些錯誤,以及錯誤產生的原因。

『玖』 python程序出現異常程序中止怎麼解決

try :
可能出現異常的代碼
except nameerror:#捕捉異常
print("錯誤提示名字錯誤")

『拾』 Python 異常處理總結

什麼是異常?

異常即是一個事件,該事件會在程序執行過程中發生,影響了程序的正常執行。一般情況下,在Python無法正常處理程序時就會發生一個異常。

異常是Python對象,表示一個錯誤。當Python腳本發生異常時我們需要捕獲處理它,否則程序會終止執行。

python提供了兩個非常重要的功能來處理python程序在運行中出現的異常和錯誤。你可以使用該功能來調試python程序。

異常處理: 本站Python教程會具體介紹。
斷言(Assertions):本站Python教程會具體介紹。

異常處理

捕捉異常可以使用try/except語句。try/except語句用來檢測try語句塊中的錯誤,從而讓except語句捕獲異常信息並處理。如果你不想在異常發生時結束你的程序,只需在try里捕獲它。

語法:

以下為簡單的try….except…else的語法:

try的工作原理是,當開始一個try語句後,python就在當前程序的上下文中作標記,這樣當異常出現時就可以回到這里,try子句先執行,接下來會發生什麼依賴於執行時是否出現異常。

· 如果當try後的語句執行時發生異常,python就跳回到try並執行第一個匹配該異常的except子句,異常處理完畢,控制流就通過整個try語句(除非在處理異常時又引發新的異常)。

· 如果在try後的語句里發生了異常,卻沒有匹配的except子句,異常將被遞交到上層的try,或者到程序的最上層(這樣將結束程序,並列印預設的出錯信息)。

· 如果在try子句執行時沒有發生異常,python將執行else語句後的語句(如果有else的話),然後控制流通過整個try語句。

實例

下面是簡單的例子,它打開一個文件,在該文件中的內容寫入內容,且並未發生異常:

以上程序輸出結果:

實例

下面是簡單的例子,它打開一個文件,在該文件中的內容寫入內容,但文件沒有寫入許可權,發生了異常:

以上程序輸出結果:

使用except而不帶任何異常類型

你可以不帶任何異常類型使用except,如下實例:

以上方式try-except語句捕獲所有發生的異常。但這不是一個很好的方式,我們不能通過該程序識別出具體的異常信息。因為它捕獲所有的異常。

使用except而帶多種異常類型

你也可以使用相同的except語句來處理多個異常信息,如下所示:

try-finally 語句

try-finally 語句無論是否發生異常都將執行最後的代碼。

實例

如果打開的文件沒有可寫許可權,輸出如下所示:

同樣的例子也可以寫成如下方式:

當在try塊中拋出一個異常,立即執行finally塊代碼。finally塊中的所有語句執行後,異常被再次提出,並執行except塊代碼。參數的內容不同於異常。

異常的參數

一個異常可以帶上參數,可作為輸出的異常信息參數。你可以通過except語句來捕獲異常的參數,如下所示:

變數接收的異常值通常包含在異常的語句中。在元組的表單中變數可以接收一個或者多個值。

元組通常包含錯誤字元串,錯誤數字,錯誤位置。

實例

以下為單個異常的實例:

以上程序執行結果如下:

觸發異常

我們可以使用raise語句自己觸發異常

raise語法格式如下:

語句中Exception是異常的類型(例如,NameError)參數是一個異常參數值。該參數是可選的,如果不提供,異常的參數是」None」。

最後一個參數是可選的(在實踐中很少使用),如果存在,是跟蹤異常對象。

實例

一個異常可以是一個字元串,類或對象。 Python的內核提供的異常,大多數都是實例化的類,這是一個類的實例的參數。

定義一個異常非常簡單,如下所示:

注意:為了能夠捕獲異常,」except」語句必須有用相同的異常來拋出類對象或者字元串。

例如我們捕獲以上異常,」except」語句如下所示:

用戶自定義異常

通過創建一個新的異常類,程序可以命名它們自己的異常。異常應該是典型的繼承自Exception類,通過直接或間接的方式。

以下為與RuntimeError相關的實例,實例中創建了一個類,基類為RuntimeError,用於在異常觸發時輸出更多的信息。

在try語句塊中,用戶自定義的異常後執行except塊語句,變數 e 是用於創建Networkerror類的實例。

在你定義以上類後,你可以觸發該異常,如下所示:

來源 | 腳本之家 原文鏈接:http://www.jb51.net/article/47996.htm

熱點內容
十彩掛機腳本 發布:2022-06-27 09:18:15 瀏覽:296
雞啄米的c編程入門系列 發布:2022-06-27 09:16:05 瀏覽:784
linux沒有eth0 發布:2022-06-27 09:15:02 瀏覽:362
oraclesql重復數據 發布:2022-06-27 09:14:57 瀏覽:927
sql2000forwincc 發布:2022-06-27 09:14:51 瀏覽:172
rust有些伺服器為什麼進不去 發布:2022-06-27 09:14:48 瀏覽:50
貢獻的演算法 發布:2022-06-27 09:13:42 瀏覽:658
六位數服務密碼在哪裡 發布:2022-06-27 09:13:33 瀏覽:799
手機訪問暗 發布:2022-06-27 09:10:37 瀏覽:851
如何給win7設置密碼 發布:2022-06-27 09:10:29 瀏覽:965